library(readr)
library(brms)
library(dplyr)
library(readr)
library(MASS)
library(phondist)
setwd("G:/ڪݵw/1. Current research/Phonotactics/judgement-experiment/phonology-v2")

#Generation of all possible syls

onsets = c("0","b", "p", "m", "f", "d", "t", "n", "l", "g", "k", "N", "h", "G", "K", "w", "z", "c", "s", "j")
nuclei = c("A", "a", "e", "i", "o", "u", "O", "Y")
codas = c("0", "i", "u", "m", "n", "N", "p", "t", "k", "Y")
tones = c("1", "2", "3", "4","5","6")
allsyllables = vector(length=length(onsets) * length(nuclei) * length(codas) * length(tones))
j = 1
syllableswt = character()
poss_onsets = character()
poss_nuclei = character()
poss_coda = character()
poss_tone = character()
for( i in onsets){
  for(n in nuclei){
    for(f in codas){
      for(t in tones){
        poss_onsets[j] = i
        poss_nuclei[j] = n
        poss_coda[j] = f
        poss_tone[j] = t
        syllableswt[j] = paste(i, n, f, t, sep="")
        j = j + 1
      }
    }
  }
}

all_poss_syls = cbind(o = poss_onsets, n = poss_nuclei, c = poss_coda, t = poss_tone, string = syllableswt) %>% data.frame(stringsAsFactors = F)

existing_syls = read_csv("all_parsed_syls_wt.csv") %>% mutate(string = paste0(o,n,c,t))
nonce_syls = all_poss_syls %>% filter(!(string %in% existing_syls$string)) %>%
  filter(n != c) %>%
  filter(!(string %in% c("gO04","cAN4","Noi4","me02","toY5","lON1","KaN2","so04","jai1","hon1","cAp2","pui3","tO05","jip2","hai6","mok2","gON1","cAm3","coi2","pei1","loY6","ham2","coi1","mA06","hYt3"))) %>%
  filter(!(o == "n" & paste0("l",substring(string,2,4)) %in% all_poss_syls$string)) %>%
  filter(!(o == "N" & paste0("0",substring(string,2,4)) %in% all_poss_syls$string)) %>%
  filter(!(o == "0" & paste0("N",substring(string,2,4)) %in% all_poss_syls$string))  %>%
  filter(!(o %in% c("K", "G") & n == "u"))

nnonce = nrow(nonce_syls)
#selected = ceiling(runif(288,0,nnonce))
selected_syls = nonce_syls[selected,]
View(selected_syls)
selected_syls = selected_syls %>% mutate(n = case_when(string == "sAi4" ~ "a", T ~ n), string = case_when(string == "sAi4" ~ "sai4", T ~ string))
selected_syls = selected_syls %>% mutate(c = case_when(string == "gep6" ~ "t", T ~ n), string = case_when(string == "gep6" ~ "get6", T ~ string)) %>%
  mutate(t = case_when(string == "gaN1" ~ "4", T ~ n), string = case_when(string == "gaN1" ~ "gaN4", T ~ string))


write_csv(selected_syls, "exp_design_v2.csv")


#Fixing things
selected_syls = read_csv("exp_design_v2.csv") %>% mutate(c = substring(string,3,3), t = substring(string,4,4))
dupes = selected_syls %>% group_by(string) %>% count() %>% ungroup() %>% filter(n > 1) %>% pull(string)
ndupe = length(dupes)
dupes_fulltable = selected_syls %>% filter(string %in% dupes) %>% group_by(o, n, c, t, string) %>% count() %>% ungroup() %>% dplyr::select(c(-nn))
selected_syls = selected_syls %>% filter(!(selected_syls$string %in% dupes)) %>% rbind(dupes_fulltable)

#newSyls = setdiff(ceiling(runif(288,0,nnonce)), nonce_syls$string %in% selected_syls$string %>% which)[1:ndupe]
selected_syls = selected_syls %>% rbind(nonce_syls[newSyls,])
selected_syls = selected_syls %>% mutate(t = case_when(string == "kwai3" ~ "6", T ~ t)) %>% 
  mutate(c = case_when(string == "hok2" ~ "t", T ~ c)) %>%
  mutate(t = case_when(string == "jAu1" ~ "2", T ~ t)) %>%
  mutate(t = case_when(string == "sAu1" ~ "5", T ~ t)) %>%
  mutate(c = case_when(string == "sON3" ~ "n", T ~ c)) %>%
  mutate(c = case_when(string == "ban3" ~ "N", T ~ c)) %>%
  mutate(string = paste0(o,n,c,t))

write_csv(selected_syls, "exp_design_v2.2.csv")

selected_syls = selected_syls %>%
  mutate(o = case_when(string == "tOY1" ~ "p", T ~ o)) %>% 
  mutate(n = case_when(string == "sOn3" ~ "e", T ~ n)) %>%
  mutate(c = case_when(string == "lYt1" ~ "k", T ~ c)) %>%
  mutate(t = case_when(string == "tet4" ~ "5", T ~ t)) %>%
  mutate(c = case_when(string == "cOn4" ~ "t", T ~ c)) %>%
  mutate(string = paste0(o,n,c,t))
write_csv(selected_syls, "exp_design_v2.3.csv")
