
library(readr)
library(dplyr)
library(reshape2)
library(ggplot2)

data_raw = read.csv("G:/ڪݵw/1. Current research/Phonotactics/judgement-experiment/phonology-v2/raw data_PhonotacticModeling.csv", stringsAsFactor = F)

data_finished = data_raw %>% filter(Finished == "True", screenscore >= 10)
no_val_part = data_finished %>% nrow
data_finished = data_finished %>% mutate(PID = 1:no_val_part)
qnames = paste("Q",22:309,"_1",sep="")
data_melted = melt(data_finished, id.vars = "PID", measure.vars = qnames, variable.name = "Question")

density_by_part = ggplot(data_melted, aes(x = value, group = PID, col = as.factor(PID))) + geom_density()
density_by_q = ggplot(data_melted, aes(x = value, group = Question, col = as.factor(Question))) + geom_density() + theme(legend.position = "none")
density_by_q_noextreme = ggplot(data_melted %>% filter(!(value %in% c(0, 100))), aes(x = value, group = Question, col = as.factor(Question))) + geom_density() + theme(legend.position = "none")
density_by_q_noextreme

design = read.csv("G:/ڪݵw/1. Current research/Phonotactics/judgement-experiment/phonology-v2/exp_design_final.csv", stringsAsFactor = F)
colnames(design)[1] = "No."
